 boolean showVertexIds=true, showVertices=true;
 pt XX[] = new pt [4];
 void myActions() { // actions to be executed at each frame
    scribe("Edge / edge intersection");                  // prints the value of t on the screen

    if ((mousePressed)&&(!keyPressed)) dragPolygon(); // edit points
    fill(black);  strokeWeight(3);          // set fill color to black and stroke width to 3
    stroke(blue);                           // set current color to blue
    pt A=P[0]; A.show(2);  // Assign point A to P[0], show it as a disk of radius 4, show its label "A"
    pt B=P[1]; B.show(2); 
    A.to(B);                                // draw a line from A to B in current color
    stroke(green);
    pt C=P[2]; C.show(2); 
    pt D=P[3]; D.show(2); 
    C.to(D);
    int r = ee(A,B,C,D,2,XX);
    stroke(orange); strokeWeight(4); noFill();
    if (r==2) XX[0].to(XX[1]);
    noStroke(); fill(orange); for(int i=0; i<r; i++) { XX[i].show(4); };
    fill(black);   A.showLabel("A"); B.showLabel("B"); C.showLabel("C"); D.showLabel("D");
    };

int ee(pt A, pt B, pt C, pt D, float e, pt X[]) { // returns number of vertices in X[] bounding intersection of edge(A,B) and edge(C,D) with tolerance e
  int r=0;
  if ((abs(dot(U(R(V(A,B))),V(A,C)))<e)&&(abs(dot(U(R(V(A,B))),V(A,D)))<e)) {
    if(ordered(A,C,B)) X[r++]=C;
    if(ordered(A,D,B)) X[r++]=D;
    if(ordered(C,A,D)) X[r++]=A;
    if(ordered(C,B,D)) X[r++]=B;
     }
  else  if ((abs(dot(U(R(V(A,B))),V(A,C)))<e) && (ordered(A,C,B))) X[r++]=C;
  else  if ((abs(dot(U(R(V(A,B))),V(A,D)))<e) && (ordered(A,D,B))) X[r++]=D;
  else  if ((abs(dot(U(R(V(C,D))),V(C,A)))<e) && (ordered(C,A,D))) X[r++]=A;
  else  if ((abs(dot(U(R(V(C,D))),V(C,B)))<e) && (ordered(C,B,D))) X[r++]=B;
  else if (edgesCross(A, B, C, D)) {
    vec T=V(A,B);                      // make vector T=AB
    vec N = R(U(V(C,D)));               // makes unit vector N by normalizing CD and then rotating it by 90 degrees                      
    vec AC = V(A,C);
    float t = dot(AC,N) / dot(T,N); 
    X[r++] = S(A,t,T);  
    }
  return r;
  }
  
boolean ordered(pt A, pt B, pt C) {return (0<dot(V(A,B),V(A,C))) && (dot(V(A,B),V(A,C))<dot(V(A,C),V(A,C))); }
boolean edgesCross(pt A, pt B, pt C, pt D) {return (dot(U(R(V(A,B))),V(A,C))>0 != dot(U(R(V(A,B))),V(A,D))>0) 
                                                && (dot(U(R(V(C,D))),V(C,A))>0 != dot(U(R(V(C,D))),V(C,B))>0) ; }
